#!/bin/sh
#set echo -e
#set echo -c

new=echo
ct_temp="/tmp/ppp_crontab.tmp"
ct_good="/tmp/ppp_crontab.good"
rc_local="/etc/rc.d/rc.local"
rc_temp="/tmp/rc_local.tmp"

reed="`pwd`/reed"
readme="`pwd`/README.ppp"

# modem aliases
beg_str="ABORT 'NO CARRIER' ABORT BUSY '' ATZ OK"
nm="name:--name:"
pass="ssword:"


#
# command stuff
#


Crontab_Head_Grep () { grep -v "DO NOT EDIT THIS" |grep -v "Cron version" |grep -v "installed on" }

cron_grep=Crontab_Head_Grep


###
#begin setup

Begin_Setup () {
    echo ""
    echo "you need to do all steps that say (required) for the scripts to work"
    echo ""
    echo -n "do you want to see the readme? (yes,no,quit)  "

    read Start

    case $Start in
    	q*|Q*) exit 0;;

    	y*|Y*) 
	    if [ -f dialog ] ; then
	    	$reed $readme
	    else
		clear	
		more $readme
		echo
		echo "........ End of $readme ......."
		echo
	    fi
	;;

	n*|N*) echo "alrighty then..";;

    	*) $begin_setup ;;
    esac
}

begin_setup=Begin_Setup


##list the crontab entry
#

List_Crontab () { echo "`crontab -l`" }

read_crontab=`$new List_Crontab`


##make new crontab
#

Make_New_Crontab () { 
    $read_crontab > $ct_temp
    cat $ct_temp |grep -v ckip.sh | $cron_grep > $ct_good
    echo "* * * * * /usr/lib/ppp/ckip.sh" >> $ct_good
    crontab $ct_good 	
}

mk_crontab=`$new Make_New_Crontab`


## edit crontab
#

Change_Crontab () {
    echo ""
    echo -n "do you want to add ckip.sh to your crontab? (quit, yes, no)  "
    read Fix_Crontab

    case $Fix_Crontab in
	q*|Q*) echo "Quitting"; exit 0 
	;;
                        
    	y*|Y*) 
	    echo "you'll need to edit the mk*_html files and ftp_ip"
	    $mk_crontab
	    echo "here is the new crontab"
	    $read_crontab
	;;

    	n*|N*) echo "Ok"
	;;

	*) $change_crontab
esac

}

change_crontab=Change_Crontab



###
# 	editing /etc/rc.d/rc.local
#


Make_New_Rclocal () { 
    echo ""
    echo "do you want to add ppp-on or stayup to your $rc_local file"	
    echo -n "that way ppp will start when you boot Linux (y,n,q)  "
    read Edit_RC

    case $Edit_RC in

	n*|N*) echo "";echo "you'll have to start ppp by your self then"
	;;

	q*|Q*) exit 0
	;;

	*)
	     echo -n "do you want ppp-on (p) or stayup (s)  "
	     read WhatPPP
	     
	     case $WhatPPP in
		p*|P*) WhatPPP="/usr/lib/ppp/ppp-on"
		;;

		*) WhatPPP="/usr/lib/ppp/stayup"
		;;
	     esac

    	     cat $rc_local |grep -v stayup|grep -v ppp-on > $rc_temp
	     cat $rc_temp > $rc_local
    	     echo "$WhatPPP &" >> $rc_local
	     echo "added $WhatPPP to $rc_local"
	;;
    esac
}

mk_rclocal=`$new Make_New_Rclocal`

 
Modem_Setup () {
	echo ""
	echo "(required)"
	echo -n "What comm port is your modem on in dos (1,2,3,4)  "
	read Dev_Modem
	
	rm -f /dev/modem
	echo "linking /dev/modem to your comm port"
	
	case $Dev_Modem in
	    1) ln -s /dev/cua0 /dev/modem;;
	    2) ln -s /dev/cua1 /dev/modem;;
	    3) ln -s /dev/cua2 /dev/modem;;
	    4) ln -s /dev/cua3 /dev/modem;;
	    *) $setup_modem;;
	esac
}

setup_modem=`$new Modem_Setup`



Login_Script () {

	echo ""
	echo "(required)"
	echo "now we are going to setup your login script"
	echo ""
	echo -n "What number will you be dialing?  "
	read Phone_No

	echo -n "What is your dial-in user name?  "
	read User_Name

	echo -n "What is your dial-in password?  "
	read Password

	echo -n "Does ppp start immediately after this? (y,n)  "
	read PPP_Now
	
	case $PPP_Now in
	    n*|N*)
		echo -n "what is the first login prompt you see?  "
		read Prompt

		echo -n "what command do you issue to start ppp?  "
		read PPP_Cmd
	    ;;	

	    *)
		Prompt=""
		PPP_Cmd=""
	    ;;

	esac


    new_scr="$beg_str ATDT$Phone_No $nm $User_Name $pass $Password '$Prompt' '$PPP_Cmd'" 

    mv login.scr login.bak
    
    echo $new_scr > login.scr
} 

mk_logscr=`$new Login_Script`


# End of commands section
#



####
###
###
#
#	This is where the script actually starts running



$begin_setup

$setup_modem

$mk_logscr

$change_crontab

$mk_rclocal

chmod 0700 *
chmod 0644 README.ppp 
chmod 0600 login.scr login.bak login* 


echo ""
echo ""
echo "all should be fixed up now except the mk*_html files, and the" 
echo "ftp_ip script.  you can type \"ppp-on &\"  or \"stayup &\" to "
echo "start ppp. have fun!" 
